---------------------------------------------------------
--Instance Module Template for BossTactics
--refer www.bosstactics.net for howto create modules!
---------------------------------------------------------

--available buttontypes:
--f: rangedDPS, h: healer, t: tank, n:melee, b,x,y,z: boss
--empty captions are not "" please use " " or you will get exceptions!

--local variable definition dont change!!
local BT_main = LibStub("AceAddon-3.0"):GetAddon( "BossTactics" )

BT_Arch = LibStub("AceAddon-3.0"):NewAddon("BT_Arch","AceConsole-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("BT_Arch")

--feel free to use localisations from the framework
local L_main = LibStub("AceLocale-3.0"):GetLocale("BossTactics")

local BabbleBoss = LibStub("LibBabble-Boss-3.0"):GetLookupTable();
local BabbleZone = LibStub("LibBabble-Zone-3.0"):GetLookupTable();

--db profile defaults add your boss-data here
local defaults = {
    profile = {
        ["instance"] = BabbleZone["Vault of Archavon"], --instance name
		["version"] = 1, --change this to a higher value for update handling (explained in a tutorial)
		["initial"] = true, --never change this flag!
		["id"] = "BT_Arch", --very important this must be the same name as your module case sensitive!
		["info"] = L["info"], --a short text you can add to the info frame, optional
		["patchlevel"] = "3.1.1", --put in the patchlevel to which this guide belongs to
		["bosses"] = {
			["mode25"] = {
		    -- first boss
                [1] = {
                    ["name"] = BabbleBoss["Archavon the Stone Watcher"],
                    ["ratext"] = L["ra Archavon"], --lines seperated by \n
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["25-Archavon"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["10-Trash-Archavon"],} }, --optional
                    ["imgdata"] = {
                        --first image
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Arch\\Img\\map_archavon",
                            ["btnId"] = 27, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
                                {
                                    ["y"] = -178.9103577403357,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 359.6307569291767,
                                }, -- [1]
                                {
                                    ["y"] = -140.8314794120018,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 307.014929235862,
                                }, -- [2]
                                {
                                    ["y"] = -185.4381274095383,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 258.8431786742031,
                                }, -- [3]
                                {
                                    ["y"] = -179.9982143875073,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 422.4317385240272,
                                }, -- [4]
                                {
                                    ["y"] = -228.9567118301607,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 378.2182660341908,
                                }, -- [5]
                                {
                                    ["y"] = -195.2296829469438,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 449.6309077685881,
                                }, -- [6]
                                {
                                    ["y"] = -218.077173688349,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 321.5516176894284,
                                }, -- [7]
                                {
                                    ["y"] = -265.9477605021589,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 322.6399241838664,
                                }, -- [8]
                                {
                                    ["y"] = -276.8273166378612,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 378.1263892285197,
                                }, -- [9]
                                {
                                    ["y"] = -258.3319362529874,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 428.1725453855476,
                                }, -- [10]
                                {
                                    ["y"] = -242.0124311074727,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 253.4033376277347,
                                }, -- [11]
                                {
                                    ["y"] = -300.762412111969,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 278.4264337001393,
                                }, -- [12]
                                {
                                    ["y"] = -322.5218482734053,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 337.1768285641206,
                                }, -- [13]
                                {
                                    ["y"] = -326.8738506665928,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 437.2699685971464,
                                }, -- [14]
                                {
                                    ["y"] = -263.7717413116745,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 187.037316447379,
                                }, -- [15]
                                {
                                    ["y"] = -308.3784342939376,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 224.0281851804706,
                                }, -- [16]
                                {
                                    ["y"] = -153.8871357106965,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 213.4498287803987,
                                }, -- [17]
                                {
                                    ["y"] = -209.373384828662,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 200.3941454908681,
                                }, -- [18]
                                {
                                    ["y"] = -195.2297549225064,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 151.4356840359959,
                                }, -- [19]
                                {
                                    ["y"] = -253.9799518536906,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 131.8523210467159,
                                }, -- [20]
                                {
                                    ["y"] = -327.9617972832177,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 151.4357919993398,
                                }, -- [21]
                                {
                                    ["y"] = -366.0407205962782,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 241.7366927271154,
                                }, -- [22]
                                {
                                    ["y"] = -376.9202587380898,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 312.4549142334557,
                                }, -- [23]
                                {
                                    ["y"] = -387.799976818808,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 402.7559589123565,
                                }, -- [24]
                                {
                                    ["y"] = -434.5825810282117,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 322.2464697708612,
                                }, -- [25]
                                {
                                    ["y"] = -397.5916403195574,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 175.3709414551196,
                                }, -- [26]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Archavon the Stone Watcher"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [2] = {
                    ["name"] = BabbleBoss["Emalon the Storm Watcher"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Emalon the Storm Watcher"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Emalon the Storm Watcher"],} }, --optional
                    ["ratext"] = L["ra-Emalon the Storm Watcher"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Arch\\Img\\map_emalon",
                            ["btnId"] = 19,
                            ["buttons"] = {
								{
                                    ["y"] = -188.7017693266159,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 255.2779411559008,
                                }, -- [1]
                                {
                                    ["y"] = -159.3269047816023,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 255.9725953045364,
                                }, -- [2]
                                {
                                    ["y"] = -403.0315533415885,
                                    ["type"] = "x",
                                    ["caption"] = " ",
                                    ["x"] = 425.3941087299118,
                                }, -- [3]
                                {
                                    ["y"] = -203.9336157577561,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 233.4265382193401,
                                }, -- [4]
                                {
                                    ["y"] = -273.56329684908,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 438.6588810288232,
                                }, -- [5]
                                {
                                    ["y"] = -270.2995469686585,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 159.8382731600526,
                                }, -- [6]
                                {
                                    ["y"] = -435.6703836937114,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 116.7128372562944,
                                }, -- [7]
                                {
                                    ["y"] = -429.1428119573059,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 413.7278057132149,
                                }, -- [8]
                                {
                                    ["y"] = -403.0314813660259,
                                    ["type"] = "x",
                                    ["caption"] = " ",
                                    ["x"] = 388.4032759846015,
                                }, -- [9]
                                {
                                    ["y"] = -408.4713224124943,
                                    ["type"] = "x",
                                    ["caption"] = " ",
                                    ["x"] = 94.65239929202475,
                                }, -- [10]
                                {
                                    ["y"] = -406.2954291792445,
                                    ["type"] = "x",
                                    ["caption"] = " ",
                                    ["x"] = 139.2588223659281,
                                }, -- [11]
                                {
                                    ["y"] = -203.9336157577561,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 279.1211058426655,
                                }, -- [12]
                                {
                                    ["y"] = -326.8738146788115,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 148.9584921007171,
                                }, -- [13]
                                {
                                    ["y"] = -272.4753682263457,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 357.8481741578069,
                                }, -- [14]
                                {
                                    ["y"] = -330.1376545286863,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 368.7279282263064,
                                }, -- [15]
                                {
                                    ["y"] = -231.1326590450825,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 419.0753740884179,
                                }, -- [16]
                                {
                                    ["y"] = -246.3643795189882,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 93.77336174587411,
                                }, -- [17]
                                {
                                    ["y"] = -320.3459550401556,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 72.01414600959819,
                                }, -- [18]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Emalon the Storm Watcher"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                    [6] = {
                                        ["type"] = "x",
                                        ["caption"] = L["Tempest Minion"],
                                        ["r"] = 167/255,
                                        ["g"] = 31/255,
                                        ["b"] = 159/255,
                                    },
                                },
                            },
                        },
                    },
                },
            },
            ["mode10"] = {
		    -- first boss
                [1] = {
                    ["name"] = BabbleBoss["Archavon the Stone Watcher"],
                    ["ratext"] = L["ra Archavon"], --lines seperated by \n
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["10-Archavon"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["10-Trash-Archavon"],} }, --optional
                    ["imgdata"] = {
                        --first image
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Arch\\Img\\map_archavon",
                            ["btnId"] = 12, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
                               	{
								    ["y"] = -222.4289601548487,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 269.3296402747133,
                                }, -- [1]
                                {
                                    ["y"] = -379.0964038858088,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 311.3666077390178,
                                }, -- [2]
                                {
                                    ["y"] = -248.5401827827847,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 158.750056635068,
                                }, -- [3]
                                {
                                    ["y"] = -176.7343385498513,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 407.2001260134655,
                                }, -- [4]
                                {
                                    ["y"] = -220.2529949460362,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 370.6023878033473,
                                }, -- [5]
                                {
                                    ["y"] = -189.7900038454912,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 432.2233660369953,
                                }, -- [6]
                                {
                                    ["y"] = -296.4106076515787,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 365.0706699512077,
                                }, -- [7]
                                {
                                    ["y"] = -317.0819352513743,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 241.4356909242822,
                                }, -- [8]
                                {
                                    ["y"] = -301.8506826186256,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 100.3012843631474,
                                }, -- [9]
                                {
                                    ["y"] = -194.1417723181002,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 109.0049742564359,
                                }, -- [10]
                                {
                                    ["y"] = -159.3269047816023,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 204.7460939023836,
                                }, -- [11]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Archavon the Stone Watcher"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [2] = {
                    ["name"] = BabbleBoss["Emalon the Storm Watcher"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Emalon the Storm Watcher"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Emalon the Storm Watcher"],} }, --optional
                    ["ratext"] = L["ra-Emalon the Storm Watcher"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Arch\\Img\\map_emalon",
                            ["btnId"] = 14,
                            ["buttons"] = {
                            	{
                                    ["y"] = -201.7575785733811,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 242.1304170484804,
                                }, -- [1]
                                {
                                    ["y"] = -233.3088041928014,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 85.06963586480431,
                                }, -- [2]
                                {
                                    ["y"] = -283.3549603498294,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 150.04651968985,
                                }, -- [3]
                                {
                                    ["y"] = -150.62297197079,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 254.8847926390367,
                                }, -- [4]
                                {
                                    ["y"] = -175.6463559454451,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 255.2781210948074,
                                }, -- [5]
                                {
                                    ["y"] = -416.0871286677752,
                                    ["type"] = "x",
                                    ["caption"] = " ",
                                    ["x"] = 248.0554633563906,
                                }, -- [6]
                                {
                                    ["y"] = -436.7583303103363,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 257.060919792865,
                                }, -- [7]
                                {
                                    ["y"] = -418.2630938765876,
                                    ["type"] = "x",
                                    ["caption"] = " ",
                                    ["x"] = 275.2549025093113,
                                }, -- [8]
                                {
                                    ["y"] = -201.7577765061783,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 270.4174609341036,
                                }, -- [9]
                                {
                                    ["y"] = -257.2439536485812,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 446.2749032107919,
                                }, -- [10]
                                {
                                    ["y"] = -324.6978134822178,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 85.06968084953094,
                                }, -- [11]
                                {
                                    ["y"] = -334.4897648852176,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 416.8997687574185,
                                }, -- [12]
                                {
                                    ["y"] = -268.1236537354087,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 352.4085130502449,
                                }, -- [13]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Emalon the Storm Watcher"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                    [6] = {
                                        ["type"] = "x",
                                        ["caption"] = L["Tempest Minion"],
                                        ["r"] = 167/255,
                                        ["g"] = 31/255,
                                        ["b"] = 159/255,
                                    },
                                },
                            },
                        },
                    },
                },
            },
		},
    },
}

function BT_Arch:OnInitialize()
 	--initialize database
    self.db = LibStub("AceDB-3.0"):New("BT_ArchDB", defaults, "Default") --change the name here
    self:CheckUpdate()

    table.insert(BT_main.modules,self.db.profile)
end;

------------------------------------------------
--this function is needed by the main program! dont touch it!
------------------------------------------------
function BT_Arch:GetDefaults()
	return defaults;
end;

-----------------------------------------------
--handels updates in data
--refer to the tutorial how to get version changes!
-----------------------------------------------

function BT_Arch:CheckUpdate()

	--the versions stored by the client musst be one more
	--because otherwise it woudnt been saved in the savedVariables
	if(not self.db.profile.initial)then
		if(defaults.profile.version+1 > self.db.profile.version)then

		end
	end
	self.db.profile.version = defaults.profile.version+1
	self.db.profile.initial = false
end;


----------------------------------------------------------------
--dont touch this functions!
----------------------------------------------------------------

function BT_Arch:ResetData()
	self.db:ResetDB()
	self.db.profile.version = defaults.profile.version+1
	self:Print(L["Module resetted"])
end;

function BT_Arch:OnEnable()

end

function BT_Arch:OnDisable()
    -- Called when the addon is disabled
end